package proxy.ejb;

import javax.ejb.Remote;
import javax.ejb.Stateless;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import api.ClientEjbService;
import api.ServerEjbService;

@Stateless
@Remote
public class EjbClient implements ClientEjbService {

	public final static String JNDI_NAME = "ejb:ejbTest-server-ear-1.0.0-SNAPSHOT/ejbTest-server-ejb-1.0.0-SNAPSHOT/EjbServer!api.ServerEjbService";

	private static Log LOG = LogFactory.getLog(EjbClient.class);
	private boolean running = true;

	@Override
	public void callServer(long callTimeInSeconds) {
		Context context;
		ServerEjbService serverService = null;
		String callString = "testCall";
		try {
			context = new InitialContext();
			serverService = (ServerEjbService) context.lookup(JNDI_NAME);
		} catch (NamingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		// start the timer
		running = true;
		new Thread(new Timer(callTimeInSeconds)).start();

		LOG.info("start calling");
		while (running) {
			serverService.call(callString);
		}

	}

	public class Timer implements Runnable {

		long sleepTime;

		public Timer(long sleepTime) {
			super();
			this.sleepTime = sleepTime;
		}

		/**
		 * @return the sleepTime
		 */
		public long getSleepTime() {
			return sleepTime;
		}

		/**
		 * @param sleepTime
		 *            the sleepTime to set
		 */
		public void setSleepTime(long sleepTime) {
			this.sleepTime = sleepTime;
		}

		@Override
		public void run() {
			LOG.info("sleeping " + sleepTime + "secs");
			try {
				Thread.sleep(sleepTime * 1000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			LOG.info("done sleeping");
			running = false;

		}

	}

}
